
% Evans root locus of the speed controlled system with NOTCH  motora. 

JM= 0.0007;
JL= 0.0007;
KK = 317;
KV = 0.12;
JEQ = JM + JL;

WP = sqrt(KK*(JM+JL)/JM/JL);
WZ = sqrt(KK/JL);

XP = sqrt(KV*KV*(JM+JL)/4/JM/JL/KK);
XZ = sqrt(KV*KV/4/JL/KK);

numr = [1  2*XZ*WZ  WZ*WZ];
denr = [1  2*XP*WP  WP*WP];
denj = [ JEQ  0]; 
numj = WP*WP/WZ/WZ; 

WHF = 2000;       % double pole, 2000 rad/s
denhf = [1  2*WHF WHF*WHF];
numhf = WHF*WHF; 

[num,den]=series(numr,denr,numhf,denhf);
[num,den]=series(num,den,numj,denj);
ss1 = tf(num,den); 

rlocus(num,den);
axis([-2500 500 -3500 3500]); 
pause

k = 3.14895; roots(den+k*num);

pause

WNF = sqrt(KK*(JM+JL)/JM/JL);
XZNF = cos(acos(XP)-0.1);        % An error of 0.1 rad
XPNF = 1; 

%XZNF = XP; With precise zeros, still not perfect cancelation. 
%XPNF = 2;  Better stability for XPNF > 1
%XZNF = XP; Ponistenje ovako nije idealno, jer je ucestanost
%XPNF = XZ; nula i polova Notcha ista, a rezonance NIJE !!!


numnf = [1  2*XZNF*WNF  WNF*WNF];
dennf = [1  2*XPNF*WNF  WNF*WNF];

close all
 
[numc,denc]=series(num,den,numnf,dennf);

rlocus(numc,denc);
axis([-2500 500 -3500 3500]); 

ss2 = tf(numc,denc); 


% sisotool